#ifndef GPS_H_
#define GPS_H_

 #include "usart.h"

 #define Buffer_Size 150
 #define degrees_buffer_size 20

 extern char Latitude_Buffer[15];
 extern char Longitude_Buffer[15];
 extern char Time_Buffer[15];
 extern char Altitude_Buffer[8];

 extern char degrees_buffer[degrees_buffer_size];   /* save latitude or longitude in degree */
 extern char GGA_Buffer[Buffer_Size];               /* save GGA string */
 extern uint8_t GGA_Pointers[20];                   /* to store instances of ',' */
 extern char GGA_CODE[3];

 extern volatile uint16_t GGA_Index, CommaCounter;

 extern bool	IsItGGAString, flag1,	flag2;

void get_gpstime();

void get_latitude(uint16_t lat_pointer);

void get_longitude(uint16_t long_pointer);

void get_altitude(uint16_t alt_pointer);

void convert_time_to_UTC();

void convert_to_degrees(char *raw);

ISR (USART0_RX_vect);

#endif // GPS_H_
