#include "lcd.h"
#include "gps.h"
#include "pff.h"
#include "usart.h"		/* include USART library */

#include <stdio.h>

#define LED PORTB					/* connected LED on PORT pin */
#define NUM_OF_COORDS 150

FATFS FatFs;   /* Work area (filesystem object) for logical drive */
char to_write[1000];

int main() {
	GGA_Index=0;
	memset(GGA_Buffer, 0, Buffer_Size);
	memset(degrees_buffer,0,degrees_buffer_size);

	LCD_init();              /* initialize LCD16x2 */
	_delay_ms(3000);         /* wait for GPS receiver to initialize */
	USART_Init(9600);        /* initialize USART with 9600 baud rate */
	sei();

	FRESULT ret;     /* FatFs return code */
	WORD bw; // number of bytes written
	char buffer[200];
	int count_mount = 0;
	int count = 0;

	/* Register work area to the default drive */
	mount:
		if (count_mount >= 10){
			LCD_printAt(0, "Mount Error");
			return 0;
		}

		if(pf_mount(&FatFs) != FR_OK) {
			count_mount++;
			// wait a while and retry
			_delay_ms(1000);
			goto mount;
		}

	/* Open a text file */
	ret = pf_open("output");
	if (ret != FR_OK) {
		LCD_printAt(0, "File not opened");
		return 0;
	}

	strcpy(to_write, "latitude,longitude\n");

	while (1)
	{
		_delay_ms(1000);

		get_gpstime();                   /* Extract Time in UTC */
		buffer[0] = '\0';

		get_latitude(GGA_Pointers[0]);   /* Extract Latitude */
		strcat(buffer, degrees_buffer);
		memset(degrees_buffer,0,degrees_buffer_size);

		get_longitude(GGA_Pointers[2]);  /* Extract Longitude */
		strcat(buffer, ", ");
		strcat(buffer, degrees_buffer);

		strcat(buffer, "\n");
		memset(degrees_buffer,0,degrees_buffer_size);

		get_altitude(GGA_Pointers[7]);   /* Extract Altitude in meters*/

		buffer[strlen(buffer)] = '\0';
		LCD_printAt(0, buffer); /* Degugging */

		if (strstr(buffer, "0.0000") == NULL) { /* Check GPS Signal*/
				count++;
				strcat(to_write, buffer);

				buffer[strlen(buffer) - 1] ='x';
				buffer[strlen(buffer)] ='\0';
				USART_SendString(buffer);
		}

		if (count == NUM_OF_COORDS) {
			ret = pf_write(to_write, sizeof(to_write),  &bw);
			if (ret != FR_OK) {
				LCD_print("Write failed");
				return 0;
			}
			LCD_printAt(LCD_INSTR_nextLine, "File is ready");
			return 0;
		}

	}

  return 0;
}
